/*!
*
*   JSBeams : Numerical solution of beam structures in JavaScript
*                      version 0.6 (2012-04-20)
*
*             Copyright (C)  2011 - 2012  Jan Stransky
*
*      Czech Technical University, Faculty of Civil Engineering,
*  Department of Structural Mechanics, 166 29 Prague, Czech Republic
*
*
*  JSBeams is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  JSBeams is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
var JSB2D_CLAMPED_CLAMPED=0;var JSB2D_CC=0;var JSB2D_CLAMPED_HINGE=1;var JSB2D_CH=1;var JSB2D_HINGE_CLAMPED=2;var JSB2D_HC=2;var JSB2D_HINGE_HINGE=3;var JSB2D_HH=3;var JSB2D_TRUSS=3;setdiff=function(d,g){var f=[];for(a=0;a<d.length;a++){var e=1;for(var c=0;c<g.length;c++){if(d[a]==g[c]){e=0;break}}if(e){f.push(d[a])}}return f};Node=function(b,d,c){this.x=b||0;this.y=d||0;this.z=c||0};Node.prototype.toString=function(){return"Node ( "+this.x+", "+this.y+", "+this.z+" )"},Node.prototype.setXYZ=function(b,d,c){this.x=b;this.y=d;this.z=c},Node.prototype.setXZ=function(b,c){this.x=b;this.z=c},Node.prototype.setYZ=function(c,b){this.y=c;this.z=b},Node.prototype.setX=function(b){this.x=b},Node.prototype.setY=function(b){this.y=b},Node.prototype.setZ=function(b){this.z=b},Node.prototype.translate=function(d,c,b){this.x+=d;this.y+=c;this.z+=b},Node.prototype.translateXZ=function(c,b){this.translate(c,0,b)},Node.prototype.translateYZ=function(c,b){this.translate(0,c,b)},Node.prototype.translateX=function(b){this.translate(b,0,0)},Node.prototype.translateY=function(b){this.translate(0,b,0)},Node.prototype.translateZ=function(b){this.translate(0,0,b)},Node.prototype.sub=function(b){return new Node(this.x-b.x,this.y-b.y,this.z-b.z)},Node.prototype.add=function(b){return new Node(this.x+b.x,this.y+x.y,this.z+b.z)},Node.prototype.mulf=function(b){return new Node(b*this.x,b*this.y,b*this.z)},Node.prototype.cross=function(b){return new Node(this.y*b.z-this.z*b.y,this.z*b.x-this.x*b.z,this.x*b.y-this.y*b.x)},Node.prototype.dot=function(b){return this.x*b.x+this.y*b.y+this.z*b.z},Node.prototype.squaredNorm=function(){return this.dot(this)},Node.prototype.norm=function(){return Math.sqrt(this.dot(this))},Node.create=function(b,e,d){var c=new Node(b,e,d);return c};Beam2d=function(c,b,d){var d=d==undefined?{}:d;this.node1=c||null;this.node2=b||null;this.type=d.type||JSB2D_CC;this.dofs=d.dofs||[0,1,2,3,4,5];this.ei=d.ei||1;this.ea=d.ea||1;this.fzloc=d.fzloc||0;this.fxloc=d.fxloc||0;this.mu=d.mu||1;this.dT=d.dT||0;this.dTh=d.dTh||0;this.alpha=d.alpha||0.000012;this.kloc=null;this.a=null;this.b=null;this.kaa=null;this.kab=null;this.kba=null;this.kbb=null;this.t=new Matrix();this.tt=new Matrix();this.mloc=new Matrix();this.m=new Matrix();this.load=Vector.Zeros(6);this.loadCC=Vector.Zeros(6);this.dspl=Vector.Zeros(6);this.eigShapes=[];this.len=null;this.sin=null;this.cos=null};Beam2d.prototype.setGeom=function(){var c=(this.node2.x-this.node1.x);var b=(this.node2.z-this.node1.z);this.len=Math.sqrt(c*c+b*b);this.cos=c/this.len;this.sin=b/this.len},Beam2d.prototype.hasBodyLoad=function(){return this.fzloc||this.fxloc||this.dT||this.dTh},Beam2d.prototype.setStiffAndTrsfMats=function(){var d=this.len;var b=this.ea/d;var i=this.ei/d;var g=i/d;var f=g/d;var h=this.sin;var j=this.cos;switch(this.type){case JSB2D_HC:this.t.fromArray([[j,h,0,0,0],[-h,j,0,0,0],[0,0,j,h,0],[0,0,-h,j,0],[0,0,0,0,1]]);this.tt.fromArray([[j,-h,0,0,0],[h,j,0,0,0],[0,0,j,-h,0],[0,0,h,j,0],[0,0,0,0,1]]);break;case JSB2D_CH:this.t.fromArray([[j,h,0,0,0],[-h,j,0,0,0],[0,0,1,0,0],[0,0,0,j,h],[0,0,0,-h,j]]);this.tt.fromArray([[j,-h,0,0,0],[h,j,0,0,0],[0,0,1,0,0],[0,0,0,j,-h],[0,0,0,h,j]]);break;case JSB2D_HH:this.t.fromArray([[j,h,0,0],[-h,j,0,0],[0,0,j,h],[0,0,-h,j]]);this.tt.fromArray([[j,-h,0,0],[h,j,0,0],[0,0,j,-h],[0,0,h,j]]);break;default:this.t.fromArray([[j,h,0,0,0,0],[-h,j,0,0,0,0],[0,0,1,0,0,0],[0,0,0,j,h,0],[0,0,0,-h,j,0],[0,0,0,0,0,1]]);this.tt.fromArray([[j,-h,0,0,0,0],[h,j,0,0,0,0],[0,0,1,0,0,0],[0,0,0,j,-h,0],[0,0,0,h,j,0],[0,0,0,0,0,1]])}var e=Matrix.create([[b,0,0,-b,0,0],[0,12*f,-6*g,0,-12*f,-6*g],[0,-6*g,4*i,0,6*g,2*i],[-b,0,0,b,0,0],[0,-12*f,6*g,0,12*f,6*g],[0,-6*g,2*i,0,6*g,4*i]]);if(this.type){switch(this.type){case JSB2D_HC:this.a=[0,1,3,4,5];this.b=[2];break;case JSB2D_CH:this.a=[0,1,2,3,4];this.b=[5];break;case JSB2D_HH:this.a=[0,1,3,4];this.b=[2,5];break}this.kaa=e.getSubMatrix(this.a,this.a);this.kab=e.getSubMatrix(this.a,this.b);this.kba=e.getSubMatrix(this.b,this.a);this.kbbinv=e.getSubMatrix(this.b,this.b).inv();this.kloc=this.kaa.sub(this.kab.mulm(this.kbbinv).mulm(this.kba))}else{this.kloc=e}},Beam2d.prototype.computeGlobStiffMatrix=function(){return this.tt.mulm(this.kloc).mulm(this.t)},Beam2d.prototype.setMassMats=function(){var e=this.len;var d=this.mu;var b=d*e/420;var f=this.sin;var g=this.cos;this.Mloc.fromArray([[140*b,0,0,70*b,0,0],[0,156*b,-22*e*b,0,54*b,13*b*e],[0,-22*e*b,4*b*e*e,0,-13*b*e,-3*b*e*e],[70*b,0,0,140*b,0,0],[0,54*b,-13*b*e,0,156*b,22*b*e],[0,13*b*e,-3*b*e*e,0,22*b*e,4*b*e*e]])},Beam2d.prototype.linearStaticPreproc=function(){this.setGeom();this.setStiffAndTrsfMats();this.load.zero();if(this.hasBodyLoad()){this.loadCC.fromArray([this.ea*this.alpha*this.dT-0.5*this.fxloc*this.len,-0.5*this.fzloc*this.len,this.fzloc*this.len*this.len/12+this.ei*this.alpha*this.dTh,-this.ea*this.alpha*this.dT-0.5*this.fxloc*this.len,-0.5*this.fzloc*this.len,-this.fzloc*this.len*this.len/12-this.ei*this.alpha*this.dTh]);if(this.type){this.load.zero();this.load.setSubVector(this.a,this.loadCC.getSubVector(this.a).sub(this.kab.mulm(this.kbbinv).mulv(this.loadCC.getSubVector(this.b))))}else{this.load=this.loadCC}}},Beam2d.prototype.linearStaticPostpro=function(c,b){var b=b||true;var c=b?this.t.mulv(c):c;if(this.type){this.dspl.zero();this.dspl.setSubVector(this.a,c);this.dspl.setSubVector(this.b,this.kbbinv.mulv(this.loadCC.getSubVector(this.b).add(this.kba.mulv(c))).negated());this.load.zero();this.load.setSubVector(this.a,this.kloc.mulv(c).add(this.loadCC.getSubVector(this.a).sub(this.kab.mulm(this.kbbinv).mulv(this.loadCC.getSubVector(this.b)))))}else{this.dspl=c;this.load=this.kloc.mulv(this.dspl).add(this.loadCC)}},Beam2d.prototype.eigenvalueDynamicPreproc=function(){this.setGeom();this.setStiffAndTrsfMats();this.setMassMats()},Beam2d.prototype.eigenvalueDynamicPostpro=function(c,b){this.eigShapes[c]=this.tt.mulv(b)},Beam2d.prototype.giveMidDeflFromLoad=function(){return this.fzloc*this.len*this.len*this.len*this.len/(384*this.ei)},Beam2d.prototype.giveMidDeflFromDspl=function(){return 0.5*(this.dspl[1]+this.dspl[4])+this.len/8*(-this.dspl[2]+this.dspl[5])},Beam2d.prototype.giveMidDefl=function(){return this.giveMidDeflFromDspl()+this.giveMidDeflFromLoad()},Beam2d.prototype.giveMidDeflOfEigShape=function(b){var c=this.eigShapes[b];return 0.5*(c[1]+c[4])+this.len/8*(-c[2]+c[5])},Beam2d.prototype.giveMidMoment=function(){return -this.load[2]-this.load[1]*this.len*0.5-this.fzloc*this.len*this.len*0.125},Beam2d.create=function(c,b,e){var d=new Beam2d(c,b,e);d.setGeom();return d};LinearStaticSolver=function(h,b,f,c,e,d,g){this.beams=h;this.u=b;this.p=f;this.nDofs=this.u.length+this.p.length;this.nodalLoad=e==undefined?Vector.Zeros(this.nDofs):e;this.withPrescribedDspl=d==undefined?false:d;this.computeReactions=g==undefined?false:g;this.k=Matrix.Zeros(this.nDofs,this.nDofs);this.dspl=c==undefined?Vector.Zeros(this.nDofs):c;this.beamLoad=Vector.Zeros(this.nDofs);this.load=Vector.Zeros(this.nDofs)};LinearStaticSolver.prototype.assemble=function(){this.k.zero();for(var c=0;c<this.beams.length;c++){var b=this.beams[c];var d=b.dofs;b.computeGlobStiffMatrix().assemble(this.k,d,d)}},LinearStaticSolver.prototype.solve=function(){this.load=this.nodalLoad.add(this.beamLoad);var e=this.k.getSubMatrix(this.u,this.u);var f=this.k.getSubMatrix(this.p,this.u);var g=this.load.getSubVector(this.u);if(this.withPrescribedDspl){var b=this.k.getSubMatrix(this.u,this.p);var c=this.k.getSubMatrix(this.p,this.p);var d=this.dspl.getSubVector(this.p);this.dspl.setSubVector(this.u,e.linSolve(g.sub(b.mulv(d))));if(this.computeReactions){this.load.setSubVector(this.p,f.mulv(this.dspl.getSubVector(this.u)).add(c.mulv(d)));this.load.isub(this.beamLoad)}}else{this.dspl.setSubVector(this.u,e.linSolve(g));if(this.computeReactions){this.load.setSubVector(this.p,f.mulv(this.dspl.getSubVector(this.u)));this.load.isub(this.beamLoad)}}},LinearStaticSolver.prototype.preprocBeams=function(){this.beamLoad.zero();for(var c=0;c<this.beams.length;c++){var b=this.beams[c];b.linearStaticPreproc();if(b.type){this.beamLoad.decrSubVector(b.dofs,b.tt.mulv(b.load.getSubVector(b.a)))}else{this.beamLoad.decrSubVector(b.dofs,b.tt.mulv(b.load))}}},LinearStaticSolver.prototype.updateBeams=function(){for(var c=0;c<this.beams.length;c++){var b=this.beams[c];b.linearStaticPostpro(this.dspl.getSubVector(b.dofs))}},LinearStaticSolver.prototype.update=function(b,c){var b=b==undefined?true:b;var c=c==undefined?true:c;if(b){this.preprocBeams()}this.assemble();this.solve();if(c){this.updateBeams()}},LinearStaticSolver.create=function(i,c,g,d,f,e,h){var b=new LinearStaticSolver(i,c,g,d,f,e,h);return b};EigenValueDynamicSolver=function(g,b,e,f,d){this.beams=g;this.u=b;this.p=e;this.nDofs=this.u.length+this.p.length;this.nEigModes=f==undefined?1:f;this.concMass=d==undefined?Vector.Zeros(this.nDofs):d;this.k=Matrix.Zeros(this.nDofs,this.nDofs);this.m=Matrix.Zeros(this.nDofs,this.nDofs);this.eigFreqs=[];for(var c=0;c<this.nEigModes;c++){this.eigFreqs[c]=0}this.eigShapes=[];for(var c=0;c<this.nEigModes;c++){this.eigShapes[c]=Vector.Zeros(this.nDofs)}};EigenValueDynamicSolver.prototype.assemble=function(){this.k.zero();this.m.zero();for(var c=0;c<this.beams.length;c++){var b=this.beams[c];var e=b.dofs;b.computeGlobStiffMatrix().assemble(this.k,e,e);this.m.incrSubMatrix(e,e,b.m)}for(var d=0;d<this.nDofs;d++){this.m[d][d]+=this.concMass[d]}},EigenValueDynamicSolver.prototype.solve=function(){var d=this.k.getSubMatrix(this.u,this.u);var d=this.m.getSubMatrix(this.u,this.u);var c=eigSolve(Kuu,Muu,this.nEigModes);for(var b=0;b<this.nEigModes;b++){this.eigFreqs[b]=c[0][b];this.eigShapes[b].setSubVector(this.u,c[1][b])}},EigenValueDynamicSolver.prototype.preprocBeams=function(){for(var b=0;b<this.beams.length;b++){this.beams[b].eigenvalueDynamicPreproc()}},EigenValueDynamicSolver.prototype.updateBeams=function(){for(var d=0;d<this.nEigModes;d++){for(var c=0;c<this.beams.length;c++){var b=this.beams[c];b.eigenvalueDynamicPostpro(d,this.eigShapes[d].getSubVector(b.dofs))}}},EigenValueDynamicSolver.prototype.update=function(b,c){var b=b==undefined?true:b;var c=c==undefined?true:c;if(b){this.preprocBeams()}this.assemble();this.solve();if(c){this.updateBeams()}},EigenValueDynamicSolver.create=function(g,c,e,f,d){var b=new EigenValueDynamicSolver(g,c,e,f,d);return b};CrossSection=function(c,b){this.nodes=c;if(this.nodes[this.nodes.length-1]!=this.nodes[0]){this.nodes.push(this.nodes[0])}this.holes=b||[[]];this.a=null;this.sy=null;this.sz=null;this.cy=null;this.cz=null;this.iy=null;this.iz=null;this.dyz=null;this.i1=null;this.i2=null;this.beta=null;this.core=null};CrossSection.prototype.reset=function(){this.a=null;this.sy=null;this.sz=null;this.cy=null;this.cz=null;this.iy=null;this.iz=null;this.dyz=null;this.i1=null;this.i2=null;this.beta=null;this.convexHull=null;this.core=null},CrossSection.prototype.computeA=function(){var c=0;var e,b;for(var d=0;d<this.nodes.length-1;d++){e=this.nodes[d];b=this.nodes[d+1];c+=e.y*b.z-b.y*e.z}return 0.5*c},CrossSection.prototype.computeSy=function(k){var k=k==undefined?false:k;var c=0;if(k){if(this.cz==null){return null}c=this.cz}var g=0;var j,e,l,h,f,b;for(var d=0;d<this.nodes.length-1;d++){j=this.nodes[d];e=this.nodes[d+1];l=j.y;h=e.y;f=j.z-c;b=e.z-c;g+=(b+f)*(l*b-h*f)}return 1/6*g},CrossSection.prototype.computeSz=function(k){var k=k==undefined?false:k;var f=0;if(k){if(this.cy==null){return null}f=this.cy}var g=0;var j,d,l,h,e,b;for(var c=0;c<this.nodes.length-1;c++){j=this.nodes[c];d=this.nodes[c+1];l=j.y-f;h=d.y-f;e=j.z;b=d.z;g+=(l+h)*(l*b-h*e)}return 1/6*g},CrossSection.prototype.computeCy=function(){var b=this.a==null?this.computeA():this.a;var c=this.sz==null?this.computeSz():this.sz;return c/b},CrossSection.prototype.computeCz=function(){var b=this.a==null?this.computeA():this.a;var c=this.sy==null?this.computeSy():this.sy;return c/b},CrossSection.prototype.computeIy=function(k){var k=k==undefined?true:k;var c=0;if(k){if(this.cz==null){return null}c=this.cz}var g=0;var j,e,l,h,f,b;for(var d=0;d<this.nodes.length-1;d++){j=this.nodes[d];e=this.nodes[d+1];l=j.y;h=e.y;f=j.z-c;b=e.z-c;g+=(f*f+f*b+b*b)*(l*b-h*f)}return 1/12*g},CrossSection.prototype.computeIz=function(k){var k=k==undefined?true:k;var f=0;if(k){if(this.cy==null){return null}f=this.cy}var g=0;var j,d,l,h,e,b;for(var c=0;c<this.nodes.length-1;c++){j=this.nodes[c];d=this.nodes[c+1];l=j.y-f;h=d.y-f;e=j.z;b=d.z;g+=(l*l+l*h+h*h)*(l*b-h*e)}return 1/12*g},CrossSection.prototype.computeDyz=function(l){var l=l==undefined?true:l;var g=0;var c=0;if(l){if(this.cy==null){return null}g=this.cy;if(this.cz==null){return null}c=this.cz}var h=0;var k,e,m,j,f,b;for(var d=0;d<this.nodes.length-1;d++){k=this.nodes[d];e=this.nodes[d+1];m=k.y-g;j=e.y-g;f=k.z-c;b=e.z-c;h+=(m*b+2*m*f+2*j*b+j*f)*(m*b-j*f)}return 1/24*h},CrossSection.prototype.computeI0=function(){var b=this.iy==null?this.computeIy():this.iy;var c=this.iz==null?this.computeIz():this.iz;return b+c},CrossSection.prototype.computeInertiaTensor=function(){var b=this.iy==null?this.computeIy():this.iy;var d=this.iz==null?this.computeIz():this.iz;var c=this.dyz==null?this.computeDyz():this.dyz;return[[b,-c],[-c,d]]},CrossSection.prototype.computePrincipalValues=function(){var b=this.iy==null?this.computeIy():this.iy;var j=this.iz==null?this.computeIz():this.iz;var f=this.dyz==null?this.computeDyz():this.dyz;if(b==j){return[b,j,0]}if(f==0){if(b>j){return[b,j,0]}else{return[j,b,0.5*Math.PI]}}var h=0.5*Math.atan(2*f/(j-b));var i=Math.cos(h);var e=Math.sin(h);var g=i*i*b+e*e*j-2*i*e*f;var d=e*e*b+i*i*j+2*i*e*f;if(g>d){return[g,d,h]}else{return[d,g,h+0.5*Math.PI]}},CrossSection.prototype.computeStress=function(g,f,e,k,j,h){var h=h||false;var i=this.a==null?this.computeA():this.a;var c=this.iy==null?this.computeIy():this.iy;var b=this.iz==null?this.computeIz():this.iz;var d=this.dyz==null?this.computeDyz():this.dyz;if(h){var g=g;var f=f}else{var g=g-(this.cy==null?this.computeCy():this.cy);var f=f-(this.cz==null?this.computeCz():this.cz)}return e/i+(k*b+j*d)/(c*b-d*d)*f-(j*c+k*d)/(c*b-d*d)*g},CrossSection.prototype.computeStressInNode=function(b,d,e,c){return this.computeStress(b.y,b.z,d,e,c)},CrossSection.prototype.computeNeutralAxis=function(i,o,m,k){var k=k||false;var l=this.a==null?this.computeA():this.a;var d=this.iy==null?this.computeIy():this.iy;var c=this.iz==null?this.computeIz():this.iz;var g=this.dyz==null?this.computeDyz():this.dyz;var b=-(m*d+o*g)/(d*c-g*g);var j=(o*c+m*g)/(d*c-g*g);var f=i/l;if(k){var h=this.cy==null?this.computeCy():this.cy;var e=this.cz==null?this.computeCz():this.cz;f+=b*h+j*e}return[b,j,f]},CrossSection.prototype.giveConvexHull=function(){if(this.nodes.length<=4){return this.nodes.slice()}var p=this.nodes[0];var o=this.nodes[0];var r=0;var q=0;for(var w=1;w<this.nodes.length;w++){if(this.nodes[w].z<p.z){p=this.nodes[w];r=w;continue}if(this.nodes[w].z>o.z){o=this.nodes[w];q=w;continue}if(this.nodes[w].z==p.z&&this.nodes[w].y<p.y){p=this.nodes[w];r=w}if(this.nodes[w].z==o.z&&this.nodes[w].y>o.y){o=this.nodes[w];q=w}}n=this.nodes.slice(0,this.nodes.length-1);var b=r<q?n.slice(r,q):n.slice(r).concat(n.slice(0,q));var j=q<r?n.slice(q,r):n.slice(q).concat(n.slice(0,r));b.push(o);j.push(p);var k,y,m,u,e,g,d,h=b.length,t=j.length;var f=[];e=0;if(h>2){do{f.push(b[e]);g=b[e];k=o.sub(g);u=100000000000000000000;for(var w=e+1;w<h;w++){d=b[w].sub(g);y=d.dot(k)/(d.norm()*k.norm());if(y<=u){if(d.cross(k).x>=0){e=w;u=y}}}}while(e<h-1)}else{f=[p]}var l=[];e=0;if(t>2){do{l.push(j[e]);g=j[e];k=p.sub(g);u=100000000000000000000;for(var w=e+1;w<t;w++){d=j[w].sub(g);y=d.dot(k)/(d.norm()*k.norm());if(y<=u){if(d.cross(k).x>=0){e=w;u=y}}}}while(e<t-1)}else{l=[o]}return f.concat(l).concat(p)},CrossSection.prototype.computeCore=function(q){var t=[];var r=this.convexHull==null?this.giveConvexHull():this.convexHull;var q=q||false;var v=this.a==null?this.computeA():this.a;var f=this.iy==null?this.computeIy():this.iy;var e=this.iz==null?this.computeIz():this.iz;var u=this.dyz==null?this.computeDyz():this.dyz;var b=this.cy==null?this.computeCy():this.cy;var l=this.cz==null?this.computeCz():this.cz;var k,h,j,g,d,c,o,m,p;for(var s=0;s<r.length-1;s++){j=r[s];g=r[s+1];d=j.y-b;c=g.y-b;o=j.z-l;m=g.z-l;p=v*(d*m-c*o);k=(u*(c-d)+e*(o-m))/p;h=(u*(o-m)+f*(c-d))/p;t[s]=q?new Node(0,k,h):new Node(0,k+b,h+l)}return t},CrossSection.prototype.update=function(){this.a=this.computeA();this.sy=this.computeSy();this.sz=this.computeSz();this.cy=this.computeCy();this.cz=this.computeCz();this.iy=this.computeIy();this.iz=this.computeIz();this.dyz=this.computeDyz();var b=this.computePrincipalValues();this.i1=b[0];this.i2=b[1];this.beta=b[2];this.convexHull=this.giveConvexHull();this.core=this.computeCore()},CrossSection.create=function(c,b){var d=new CrossSection(c,b);return d};