/*!
*
* RaphaëlSM : Raphaël extension for civil engineering mechanics drawings
*                      version 0.5.2 (2011-10-15)
*
*                 Copyright (C)  2011  Jan Stransky
*
*      Czech Technical University, Faculty of Civil Engineering,
*  Department of Structural Mechanics, 166 29 Prague, Czech Republic
*
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
GeomObj=function(){this.constructorGeomObj=function(a,b){this.raphael=a;var b=b==undefined?{}:b;this.x=b.x==undefined?0:b.x;this.z=b.z==undefined?0:b.z;this.size=b.size==undefined?1:b.size;this.angle=b.angle==undefined?0:b.angle;this.pathList=null;this.obj=null;this.sin=0;this.cos=0;this.setSinCos();this.setPathList();this.makeObj(this.raphael);this.copies=[];this.copiesShifts=[]};this.setSinCos=function(){this.sin=Math.sin(-this.angle*Math.PI/180);this.cos=Math.cos(-this.angle*Math.PI/180)};this.setPathList=function(){};this.makeObj=function(){this.obj=this.raphael.path(this.pathList)};this.attrObjPath=function(){this.obj.attr({path:this.pathList})};this.setX=function(a){this.x=a;this.up()};this.setZ=function(a){this.z=a;this.up()};this.setXZ=function(a,b){this.x=a;this.z=b;this.up()};this.translateX=function(a){this.x+=a;this.up()};this.translateZ=function(a){this.z+=a;this.up()};this.translate=function(b,a){this.x+=b;this.z+=a;this.up()};this.rotate=function(a){this.angle+=a;this.setSinCos();this.up()};this.setAngle=function(a){this.angle=a;this.setSinCos();this.up()};this.copy=function(a){for(var b=0;b<a.length;b++){this.copiesShifts.push(a[b]);this.copies.push(this.makeCopy());this.up()}};this.makeCopy=function(){};this.up=function(){this.setPathList();this.attrObjPath();for(var a=0;a<this.copies.length;a++){this.copies[a].setXZ(this.x+this.copiesShifts[a][0],this.z+this.copiesShifts[a][1])}}};Arrow=function(a,b){var b=b==undefined?{}:b;this.inheritFrom=GeomObj;this.inheritFrom();this.constructorArrow=function(c,d){this.constructorGeomObj(c,d);if(d.size==undefined){this.size=50}this.headLen=d.headLen==undefined?this.size/4:d.headLen;this.headWidth=d.headWidth==undefined?this.size/16:d.headWidth;this.up()};this.setPathList=function(){this.pathList=[["M",this.x,this.z],["L",this.x+this.cos*this.size,this.z+this.sin*this.size],["M",this.x+this.cos*this.headLen-this.sin*this.headWidth,this.z+this.sin*this.headLen+this.cos*this.headWidth],["L",this.x,this.z],["L",this.x+this.cos*this.headLen+this.sin*this.headWidth,this.z+this.sin*this.headLen-this.cos*this.headWidth]]};this.resize=function(c){if(Math.abs(c)>=1){this.headLen*=c/this.size;this.headWidth*=c/this.size;this.size=c;this.up()}};this.makeCopy=function(){var c=new Arrow(this.raphael,{x:this.x,z:this.z,size:this.size,angle:this.angle,headLen:this.headLen,headWidth:this.headWidth});c.obj.remove();c.obj=this.obj.clone();return c};this.constructorArrow(a,b)};Arrow.create=function(a,b){return new Arrow(a,b)};PinSupport=function(a,b){var b=b==undefined?{}:b;this.inheritFrom=GeomObj;this.inheritFrom();this.constructorPinSupport=function(c,d){this.constructorGeomObj(c,d);if(d.size==undefined){this.size=20}this.sliding=d.sliding==undefined?false:d.sliding;this.ratio=d.ratio==undefined?0.7:d.ratio;this.gap=d.gap==undefined?5:d.gap;this.up()};this.setPathList=function(){if(this.sliding){this.pathList=[["M",this.x,this.z],["L",this.x-this.cos*this.ratio*this.size-this.sin*this.size,this.z-this.sin*this.ratio*this.size+this.cos*this.size],["L",this.x+this.cos*this.ratio*this.size-this.sin*this.size,this.z+this.sin*this.ratio*this.size+this.cos*this.size],["Z"],["M",this.x-this.cos*this.ratio*this.size-this.sin*(this.size+this.gap),this.z-this.sin*this.ratio*this.size+this.cos*(this.size+this.gap)],["L",this.x+this.cos*this.ratio*this.size-this.sin*(this.size+this.gap),this.z+this.sin*this.ratio*this.size+this.cos*(this.size+this.gap)]]}else{this.pathList=[["M",this.x,this.z],["L",this.x-this.cos*this.ratio*this.size-this.sin*this.size,this.z-this.sin*this.ratio*this.size+this.cos*this.size],["L",this.x+this.cos*this.ratio*this.size-this.sin*this.size,this.z+this.sin*this.ratio*this.size+this.cos*this.size],["Z"]]}};this.makeCopy=function(){var c=new PinSupport(this.raphael,{x:this.x,z:this.z,size:this.size,angle:this.angle,sliding:this.sliding,gap:this.gap,ratio:this.ratio});c.obj.remove();c.obj=this.obj.clone();return c};this.constructorPinSupport(a,b)};PinSupport.create=function(a,b){return new PinSupport(a,b)};FixedSupport=function(a,b){var b=b==undefined?{}:b;this.inheritFrom=GeomObj;this.inheritFrom();this.constructorFixedSupport=function(c,d){this.constructorGeomObj(c,d);if(d.size==undefined){this.size=30}this.ratio=d.ratio==undefined?0.2:d.ratio;this.nFlags=d.nFlags==undefined?5:d.nFlags;this.reversed=d.reversed==undefined?false:d.reversed;this.up()};this.setPathList=function(){this.pathList=[["M",this.x-this.sin*this.size*0.5,this.z+this.cos*this.size*0.5],["L",this.x+this.sin*this.size*0.5,this.z-this.cos*this.size*0.5]];if(this.reversed){for(var c=0;c<this.nFlags;c++){var e=vecTrans(0,this.size*(-0.5+(c+1)/this.nFlags),this.sin,this.cos);var d=vecTrans(-this.size*this.ratio,this.size*(-0.5+c/this.nFlags),this.sin,this.cos);this.pathList.push(["M",this.x+e[0],this.z+e[1]]);this.pathList.push(["L",this.x+d[0],this.z+d[1]])}}else{for(var c=0;c<this.nFlags;c++){var e=vecTrans(0,this.size*(-0.5+c/this.nFlags),this.sin,this.cos);var d=vecTrans(-this.size*this.ratio,this.size*(-0.5+(c+1)/this.nFlags),this.sin,this.cos);this.pathList.push(["M",this.x+e[0],this.z+e[1]]);this.pathList.push(["L",this.x+d[0],this.z+d[1]])}}};this.makeCopy=function(){var c=new FixedSupport(this.raphael,{x:this.x,z:this.z,size:this.size,angle:this.angle,ratio:this.ratio,nFlags:this.nFlags,reversed:this.reversed});c.obj.remove();c.obj=this.obj.clone();return c};this.constructorFixedSupport(a,b)};FixedSupport.create=function(a,b){return new FixedSupport(a,b)};ContinuousLoad=function(f,e,d,b,a,c){this.constructorLine=function(l,k,j,h,g,i){this.raphael=l;this.point1=k;this.point2=j;this.valx=h==undefined?0:h;this.valz=g==undefined?0:g;this.nArrows=i==undefined?4:i;this.obj=this.raphael.path(this.pathList);this.up()};this.setVals=function(h,g){this.valx=h==undefined?0:h;this.valz=g==undefined?0:g;this.up()};this.setGeom=function(){this.x1=this.point1.x;this.z1=this.point1.z;this.x2=this.point2.x;this.z2=this.point2.z;this.dx=this.x2-this.x1;this.dz=this.z2-this.z1;this.len=Math.sqrt(this.dx*this.dx+this.dz*this.dz);this.cos=this.dx/this.len;this.sin=this.dz/this.len;this.lenVals=Math.sqrt(this.valx*this.valx+this.valz*this.valz);this.cosVal=this.valx/this.lenVals;this.sinVal=this.valz/this.lenVals};this.setPathList=function(){this.pathList=[["M",this.x1,this.z1],["L",this.x2,this.z2],["L",this.x2-this.valx,this.z2-this.valz],["L",this.x1-this.valx,this.z1-this.valz],["Z"]];var h=this.len/(this.nArrows+1);for(var g=1;g<=this.nArrows;g++){this.pathList.push(["M",this.x1-this.valx+g*h*this.cos,this.z1-this.valz+g*h*this.sin]);this.pathList.push(["L",this.x1+g*h*this.cos,this.z1+g*h*this.sin]);this.pathList.push(["M",this.x1+g*h*this.cos-this.cosVal*this.lenVals/4+this.sinVal*this.lenVals/16,this.z1+g*h*this.sin-this.sinVal*this.lenVals/4-this.cosVal*this.lenVals/16]);this.pathList.push(["L",this.x1+g*h*this.cos,this.z1+g*h*this.sin]);this.pathList.push(["L",this.x1+g*h*this.cos-this.cosVal*this.lenVals/4-this.sinVal*this.lenVals/16,this.z1+g*h*this.sin-this.sinVal*this.lenVals/4+this.cosVal*this.lenVals/16])}};this.attrObjPath=function(){this.obj.attr({path:this.pathList})};this.up=function(){this.setGeom();this.setPathList();this.attrObjPath()};this.constructorLine(f,e,d,b,a,c)};ContinuousLoad.create=function(f,e,d,b,a,c){return new ContinuousLoad(f,e,d,b,a,c)};CurveObj=function(){this.constructorCurveObj=function(c,b,a,d){var d=d==undefined?{}:d;this.raphael=c;this.point1=b;this.point2=a;this.scale=d.scale==undefined?1:d.scale;this.closedBegin=d.closedBegin==undefined?true:d.closedBegin;this.closedEnd=d.closedEnd==undefined?true:d.closedEnd;this.closedBase=d.closedBase==undefined?true:d.closedBase;this.setGeom();this.consts();this.setPathList();this.makeObj()};this.consts=function(){};this.setPathList=function(){};this.setGeom=function(){this.x1=this.point1.x;this.z1=this.point1.z;this.x2=this.point2.x;this.z2=this.point2.z;this.dx=this.x2-this.x1;this.dz=this.z2-this.z1;this.len=Math.sqrt(this.dx*this.dx+this.dz*this.dz);this.segLen=this.len/(this.nSeg)||1;this.cos=this.dx/this.len;this.sin=this.dz/this.len};this.makeObj=function(){this.obj=this.raphael.path(this.pathList)};this.attrObjPath=function(){this.obj.attr({path:this.pathList})};this.up=function(){this.setGeom();this.consts();this.setPathList();this.attrObjPath()};this.closedPartsHandle=function(a){if(this.closedEnd){this.pathList.push(["L",this.x2,this.z2])}else{this.pathList.push(["M",this.x2,this.z2])}if(this.closedBase){this.pathList.push(["L",this.x1,this.z1])}else{this.pathList.push(["M",this.x1,this.z1])}if(this.closedBegin){this.pathList.push(["L",this.x1-this.scale*this.sin*a,this.z1+this.scale*this.cos*a])}}};LinearCurve=function(c,b,a,d){var d=d==undefined?{}:d;this.inheritFrom=CurveObj;this.inheritFrom();this.constructorLinearCurve=function(g,f,e,h){this.constructorCurveObj(g,f,e,h);this.val1=h.val1==undefined?0:h.val1;this.val2=h.val2==undefined?0:h.val2;this.up()};this.setPathList=function(){this.pathList=[["M",this.x1-this.scale*this.sin*this.val1,this.z1+this.scale*this.cos*this.val1]];this.pathList.push(["L",this.x2-this.scale*this.sin*this.val2,this.z2+this.scale*this.cos*this.val2]);this.closedPartsHandle(this.val1)};this.setVals=function(f,e){this.val1=f;this.val2=e;this.up()};this.constructorLinearCurve(c,b,a,d)};LinearCurve.create=function(c,b,a,d){return new LinearCurve(c,b,a,d)};ParabolicCurve=function(c,b,a,d){var d=d==undefined?{}:d;this.inheritFrom=CurveObj;this.inheritFrom();this.constructorParabolicCurve=function(g,f,e,h){this.constructorCurveObj(g,f,e,h);this.val1=h.val1==undefined?0:h.val1;this.valMid=h.valMid==undefined?0:h.valMid;this.val2=h.val2==undefined?0:h.val2;this.nSeg=h.nSeg==undefined?5:h.nSeg;this.up()};this.consts=function(){this.c0=this.val1;this.c1=(-3*this.val1-this.val2+4*this.valMid)/this.len;this.c2=(2*this.val1+2*this.val2-4*this.valMid)/this.len/this.len};this.v=function(e){return this.c0+this.c1*e+this.c2*e*e};this.dv=function(e){return this.c1+2*this.c2*e};this.setPathList=function(){this.pathList=[["M",this.x1-this.scale*this.sin*this.v(0),this.z1+this.scale*this.cos*this.v(0)]];var o=0.3;for(var e=0;e<this.nSeg;e++){var n=this.v(e*this.segLen);var m=this.v((e+1)*this.segLen);var h=this.dv(e*this.segLen);var g=this.dv((e+1)*this.segLen);var k=vecTrans((e+o)*this.segLen,this.scale*(n+h*o*this.segLen),this.sin,this.cos);var j=vecTrans((e+1-o)*this.segLen,this.scale*(m-g*o*this.segLen),this.sin,this.cos);var f=vecTrans((e+1)*this.segLen,this.scale*m,this.sin,this.cos);var l=["C",this.x1+k[0],this.z1+k[1],this.x1+j[0],this.z1+j[1],this.x1+f[0],this.z1+f[1]];this.pathList.push(l)}this.closedPartsHandle(this.v(0))};this.setVals=function(f,e,g){this.val1=f;this.val2=e;this.valMid=g;this.up()};this.constructorParabolicCurve(c,b,a,d)};ParabolicCurve.create=function(c,b,a,d){return new ParabolicCurve(c,b,a,d)};DeflCurve=function(c,b,a,d){var d=d==undefined?{}:d;this.inheritFrom=CurveObj;this.inheritFrom();this.constructorDeflCurve=function(g,f,e,h){this.constructorCurveObj(g,f,e,h);this.u1=h.u1==undefined?0:h.u1;this.w1=h.w1==undefined?0:h.w1;this.phi1=h.phi1==undefined?0:h.phi1;this.u2=h.u2==undefined?0:h.u2;this.w2=h.w2==undefined?0:h.w2;this.phi2=h.phi2==undefined?0:h.phi2;this.wMid=h.wMid==undefined?0:h.wMid;this.realLen=h.realLen==undefined?1:h.realLen;this.nSeg=h.nSeg==undefined?5:h.nSeg;this.scale=h.scale==undefined?1:h.scale;this.setGeom();this.lenScale=this.realLen/this.len;this.consts();this.setPathList();this.makeObj();this.up()};this.consts=function(){this.c0=this.w1;this.c1=-this.phi1*this.lenScale;this.c2=(2*this.phi1+this.phi2)*this.lenScale/this.len+3/this.len/this.len*(this.w2-this.w1)+16/this.len/this.len*this.wMid;this.c3=2/this.len/this.len/this.len*(this.w1-this.w2)-1/this.len/this.len*this.lenScale*(this.phi1+this.phi2)-32/this.len/this.len/this.len*this.wMid;this.c4=16/this.len/this.len/this.len/this.len*this.wMid};this.w=function(e){return this.c0+this.c1*e+this.c2*e*e+this.c3*e*e*e+this.c4*e*e*e*e};this.dw=function(e){return this.c1+2*this.c2*e+3*this.c3*e*e+4*this.c4*e*e*e};this.setPathList=function(){this.pathList=[["M",this.x1+this.scale*(this.u1*this.cos-this.sin*this.w(0)),this.z1+this.scale*(this.u1*this.sin+this.cos*this.w(0))]];var o=0.3;for(var g=0;g<this.nSeg;g++){var j=this.w(g*this.segLen);var h=this.w((g+1)*this.segLen);var f=this.dw(g*this.segLen);var e=this.dw((g+1)*this.segLen);var m=vecTrans(this.scale*this.u1+(g+o)*(this.segLen+this.scale*(this.u2-this.u1)/this.nSeg),this.scale*(j+f*o*this.segLen),this.sin,this.cos);var l=vecTrans(this.scale*this.u1+(g+1-o)*(this.segLen+this.scale*(this.u2-this.u1)/this.nSeg),this.scale*(h-e*o*this.segLen),this.sin,this.cos);var k=vecTrans(this.scale*this.u1+(g+1)*(this.segLen+this.scale*(this.u2-this.u1)/this.nSeg),this.scale*h,this.sin,this.cos);var n=["C",this.x1+m[0],this.z1+m[1],this.x1+l[0],this.z1+l[1],this.x1+k[0],this.z1+k[1]];this.pathList.push(n)}this.closedPartsHandle(this.w(0))};this.setDsplFull=function(k,g,h,j,e,f,i){this.u1=k;this.w1=g;this.phi1=h;this.u2=j;this.w2=e;this.phi2=f;this.wMid=i||0;this.up()}};DeflCubic=function(c,b,a,d){var d=d==undefined?{}:d;d.wMid=0;this.inheritFrom=DeflCurve;this.inheritFrom();this.constructorDeflCurve(c,b,a,d);this.setDspl=function(j,g,h,i,e,f){this.setDsplFull(j,g,h,i,e,f,0)}};DeflCubic.create=function(c,b,a,d){return new DeflCubic(c,b,a,d)};Defl4thOrder=function(c,b,a,d){var d=d==undefined?{}:d;this.inheritFrom=DeflCurve;this.inheritFrom();this.constructorDeflCurve(c,b,a,d);this.setDspl=function(k,g,h,j,e,f,i){this.setDsplFull(k,g,h,j,e,f,i)}};Defl4thOrder.create=function(c,b,a,d){return new Defl4thOrder(c,b,a,d)};DeflCubicNoU=function(c,b,a,d){var d=d==undefined?{}:d;d.wMid=0;d.u1=0;d.u2=0;this.inheritFrom=DeflCurve;this.inheritFrom();this.constructorDeflCurve(c,b,a,d);this.setDspl=function(g,h,e,f){this.setDsplFull(0,g,h,0,e,f,0)}};DeflCubicNoU.create=function(c,b,a,d){return new DeflCubicNoU(c,b,a,d)};Defl4thOrderNoU=function(c,b,a,d){var d=d==undefined?{}:d;d.u1=0;d.u2=0;this.inheritFrom=DeflCurve;this.inheritFrom();this.constructorDeflCurve(c,b,a,d);this.setDspl=function(g,h,e,f,i){this.setDsplFull(0,g,h,0,e,f,i)}};Defl4thOrderNoU.create=function(c,b,a,d){return new Defl4thOrderNoU(c,b,a,d)};